package com.glxp.udidl.admin.controller.device;

import com.alibaba.fastjson.JSONObject;
import com.glxp.udidl.admin.entity.info.CompanyEntity;
import com.glxp.udidl.admin.entity.udid.*;
import com.glxp.udidl.admin.req.udid.DeviceRequest;
import com.glxp.udidl.admin.req.udid.DownloadDiRequest;
import com.glxp.udidl.admin.req.udid.DownloadHistoryRequest;
import com.glxp.udidl.admin.req.udid.TokenRequest;
import com.glxp.udidl.admin.res.udid.DataSetBean;
import com.glxp.udidl.admin.res.udid.MedicalHistoryResonse;
import com.glxp.udidl.admin.res.udid.MedicalResonse;
import com.glxp.udidl.admin.res.udid.MedicalSingleResponse;
import com.glxp.udidl.admin.service.info.CompanyService;
import com.glxp.udidl.admin.service.inout.DeviceService;
import com.glxp.udidl.admin.service.inout.ProductInfoService;
import com.glxp.udidl.admin.service.udi.UdiCompanyService;
import com.glxp.udidl.admin.thread.UdiTransferUtils;
import com.glxp.udidl.admin.util.DateUtil;
import com.glxp.udidl.admin.util.HttpClient;
import com.glxp.udidl.admin.util.WarehousBeanUtils;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.UUID;

public class DownloadDeviceHelper {


    CompanyEntity companyEntity;
    String url = "";
    String appId;
    String appSecret;
    final int pageSize = 400;

    UdiCompanyService udiCompanyService;

    public DownloadDeviceHelper(CompanyService companyService, UdiCompanyService udiCompanyService) {
        companyEntity = companyService.findCompany();
        if (companyEntity != null && companyEntity.getClasses() != null) {
            if (companyEntity.getClasses().equals("1")) {
                url = "company/identifier/get";
            } else {
                url = "sharing/get";
            }
            appId = companyEntity.getAppId();
            appSecret = companyEntity.getAppSecret();
        }
        this.udiCompanyService = udiCompanyService;
    }

    public TokenEntity getToken() {
        TokenRequest tokenRequest = new TokenRequest();
        tokenRequest.setAppId(appId);
        tokenRequest.setAppSecret(appSecret);
        tokenRequest.setTyshxydm(companyEntity.getTyshxydm());
        String response = HttpClient.post("token/get", tokenRequest);
        TokenEntity tokenEntity = (TokenEntity) JSONObject.parseObject(response, TokenEntity.class);
        return tokenEntity;
    }

    public int getTotal(String token) {
        DeviceRequest deviceRequest = new DeviceRequest();
        deviceRequest.setCurrentPageNumber("1");
        deviceRequest.setRequestType("3");
        deviceRequest.setAccessToken(token);
        String response = HttpClient.post(url, deviceRequest);
        MedicalResonse medicalResonse = (MedicalResonse) JSONObject.parseObject(response, MedicalResonse.class);
        return medicalResonse.getTotalPageCount();
    }

    //下载流通企业
    public int downloadDevices(ProductInfoService productInfoService, DeviceService deviceService, DeviceRequest deviceRequest) {
        String response = HttpClient.post(url, deviceRequest);
        int result = -1;
        List<DataSetBean> dataSetBeanList;
        MedicalResonse medicalResonse = null;
        if (url.equals("sharing/get")) {
            medicalResonse = (MedicalResonse) JSONObject.parseObject(response, MedicalResonse.class);
            result = medicalResonse.getReturnCode();
            dataSetBeanList = medicalResonse.getDataSet();
        } else {
            MedicalHistoryResonse medicalResonse2 = (MedicalHistoryResonse) JSONObject.parseObject(response, MedicalHistoryResonse.class);
            result = medicalResonse2.getReturnCode();
            dataSetBeanList = medicalResonse2.getDataList();
        }


        if (dataSetBeanList != null && dataSetBeanList.size() > 0) {
            for (int i = 0; i < dataSetBeanList.size(); i++) {
                DataSetBean dataSetBean = dataSetBeanList.get(i);
                Device device = WarehousBeanUtils.responseToDevice(dataSetBean);
                if (deviceService.selectisSame(device.getDevicerecordkey(), device.getVersionnumber()) == null) {
                    if (device.getBssjzt() != null && device.getBssjzt().equals("草稿")) {
                        //草稿数据忽略
                    } else {
                        String uuid = getUUId();
                        device.setUuid(uuid);

                        String versionNum = device.getVersionnumber();
                        //如果版本号大于1，说明是新增，则更新历史记录
                        if (versionNum != null && Integer.parseInt(versionNum) > 1) {
                            deviceService.deleteHistory(device.getDevicerecordkey());
                            device.setLastModifyTime(DateUtil.formatDateTime(new Date()));
                            deviceService.insertDevice(device);
                            DownloadHistoryRequest deviceHistoryRequest = new DownloadHistoryRequest();
                            deviceHistoryRequest.setAccessToken(deviceRequest.getAccessToken());
                            deviceHistoryRequest.setCurrentPageNumber("1");
                            List<DownloadHistoryRequest.DataSetBean> dataSetBeans = new ArrayList<>();
                            DownloadHistoryRequest.DataSetBean keys = new DownloadHistoryRequest.DataSetBean();
                            keys.setDeviceRecordKey(device.getDevicerecordkey());
                            dataSetBeans.add(keys);
                            deviceHistoryRequest.setDataSet(dataSetBeans);
                            downloadHistory(productInfoService, deviceHistoryRequest, deviceService);
                        } else {
                            device.setLastModifyTime(DateUtil.formatDateTime(new Date()));
                            deviceService.insertDevice(device);
                        }

                        new UdiTransferUtils().transUdi(deviceService, productInfoService, uuid, udiCompanyService);
                        List<DataSetBean.DeviceClinicalBean> deviceclinicals = dataSetBean.getDeviceClinical();
                        List<Deviceclinical> deviceclinicalList = new ArrayList<>();
                        if (deviceclinicalList != null && deviceclinicalList.size() > 0) {
                            for (DataSetBean.DeviceClinicalBean deviceClinicalBean : deviceclinicals) {
                                if (deviceClinicalBean != null) {
                                    Deviceclinical deviceclinical = WarehousBeanUtils.responseToDeviceclinical(deviceClinicalBean);
                                    deviceclinical.setDevicerecordkey(device.getDevicerecordkey());
                                    deviceclinical.setUuid(uuid);
                                    deviceclinicalList.add(deviceclinical);
                                }
                            }
                            deviceService.insertDeviceClinical(deviceclinicalList);
                        }
                        List<DataSetBean.DevicePackageBean> devicePackageBeans = dataSetBean.getDevicePackage();
                        if (devicePackageBeans != null && devicePackageBeans.size() > 0) {
                            List<Devicepackage> devicepackageList = new ArrayList<>();
                            for (DataSetBean.DevicePackageBean devicePackageBean : devicePackageBeans) {
                                Devicepackage devicepackage = WarehousBeanUtils.responseToDevicepackage(devicePackageBean);
                                devicepackage.setDevicerecordkey(device.getDevicerecordkey());
                                devicepackage.setUuid(uuid);
                                devicepackageList.add(devicepackage);
                            }
                            deviceService.insertDevicepackage(devicepackageList);
                        }

                        List<DataSetBean.DeviceStorageBean> deviceStorageBeans = dataSetBean.getDeviceStorage();
                        if (deviceStorageBeans != null && deviceStorageBeans.size() > 0) {
                            List<Devicestorage> devicestorageList = new ArrayList<>();
                            for (DataSetBean.DeviceStorageBean deviceStorageBean : deviceStorageBeans) {
                                Devicestorage devicestorage = WarehousBeanUtils.responseToDevicestorage(deviceStorageBean);
                                devicestorage.setDevicerecordkey(device.getDevicerecordkey());
                                devicestorage.setUuid(uuid);
                                devicestorageList.add(devicestorage);
                            }
                            deviceService.insertDevicestorage(devicestorageList);
                        }
                        List<DataSetBean.ContactListBean> contactListBeans = dataSetBean.getContactList();
                        if (contactListBeans != null && contactListBeans.size() > 0) {
                            List<Contactlist> contactlistList = new ArrayList<>();
                            for (DataSetBean.ContactListBean contactListBean : contactListBeans) {
                                Contactlist contactlist = WarehousBeanUtils.responseToContactlist(contactListBean);
                                contactlist.setDevicerecordkey(device.getDevicerecordkey());
                                contactlist.setUuid(uuid);
                                contactlistList.add(contactlist);
                            }
                            deviceService.insertContactlist(contactlistList);
                        }
                    }
                }
            }
        }
        if (Integer.parseInt(deviceRequest.getCurrentPageNumber()) >= medicalResonse.getTotalPageCount()) {
            return -1;
        }
        return result;
    }

    public int simpleDownloadDevices(ProductInfoService productInfoService, DeviceService deviceService, DeviceRequest deviceRequest) {
        String response = HttpClient.post(url, deviceRequest);
        int result = -1;
        List<DataSetBean> dataSetBeanList = null;
        MedicalResonse medicalResonse = null;
        if (url.equals("sharing/get")) {
            medicalResonse = (MedicalResonse) JSONObject.parseObject(response, MedicalResonse.class);
            result = medicalResonse.getReturnCode();
            dataSetBeanList = medicalResonse.getDataSet();
        }

        if (dataSetBeanList != null && dataSetBeanList.size() > 0) {
            for (int i = 0; i < dataSetBeanList.size(); i++) {
                DataSetBean dataSetBean = dataSetBeanList.get(i);
                Device device = WarehousBeanUtils.responseToDevice(dataSetBean);
            }
        }
        if (Integer.parseInt(deviceRequest.getCurrentPageNumber()) >= medicalResonse.getTotalPageCount()) {
            return -1;
        }
        return result;
    }

    //下载生产企业
    public int downloadProduct(ProductInfoService productInfoService, DeviceService deviceService, DeviceRequest deviceRequest) {
        String response = HttpClient.post(url, deviceRequest);
        MedicalHistoryResonse medicalResonse = (MedicalHistoryResonse) JSONObject.parseObject(response, MedicalHistoryResonse.class);
        if (medicalResonse.getReturnCode() == 1) {
            List<DataSetBean> dataSetBeanList = medicalResonse.getDataList();
            if (dataSetBeanList != null && dataSetBeanList.size() > 0) {
                for (int i = 0; i < dataSetBeanList.size(); i++) {
                    DataSetBean dataSetBean = dataSetBeanList.get(i);
                    Device device = WarehousBeanUtils.responseToDevice(dataSetBean);
                    if (deviceService.selectisSame(device.getDevicerecordkey(), device.getVersionnumber()) == null) {
                        if (device.getBssjzt() != null && device.getBssjzt().equals("草稿")) {
                            //草稿数据忽略
                        } else {
                            String uuid = getUUId();
                            device.setUuid(uuid);
                            String versionNum = device.getVersionnumber();
                            //如果版本号大于1，说明是新增，则更新历史记录
                            if (versionNum != null && Integer.parseInt(versionNum) > 1) {
                                deviceService.deleteHistory(device.getDevicerecordkey());
                                DownloadHistoryRequest deviceHistoryRequest = new DownloadHistoryRequest();
                                deviceHistoryRequest.setAccessToken(deviceRequest.getAccessToken());
                                deviceHistoryRequest.setCurrentPageNumber("1");
                                List<DownloadHistoryRequest.DataSetBean> dataSetBeans = new ArrayList<>();
                                DownloadHistoryRequest.DataSetBean keys = new DownloadHistoryRequest.DataSetBean();
                                keys.setDeviceRecordKey(device.getDevicerecordkey());
                                dataSetBeans.add(keys);
                                deviceHistoryRequest.setDataSet(dataSetBeans);
                                downloadHistory(productInfoService, deviceHistoryRequest, deviceService);
                            }

                            deviceService.insertDevice(device);
                            List<DataSetBean.DeviceClinicalBean> deviceclinicals = dataSetBean.getDeviceClinical();
                            List<Deviceclinical> deviceclinicalList = new ArrayList<>();
                            for (DataSetBean.DeviceClinicalBean deviceClinicalBean : deviceclinicals) {
                                if (deviceClinicalBean != null) {
                                    Deviceclinical deviceclinical = WarehousBeanUtils.responseToDeviceclinical(deviceClinicalBean);
                                    deviceclinical.setDevicerecordkey(device.getDevicerecordkey());
                                    deviceclinical.setUuid(uuid);
                                    deviceclinicalList.add(deviceclinical);
                                }
                            }
                            deviceService.insertDeviceClinical(deviceclinicalList);

                            List<DataSetBean.DevicePackageBean> devicePackageBeans = dataSetBean.getDevicePackage();
                            List<Devicepackage> devicepackageList = new ArrayList<>();
                            for (DataSetBean.DevicePackageBean devicePackageBean : devicePackageBeans) {
                                Devicepackage devicepackage = WarehousBeanUtils.responseToDevicepackage(devicePackageBean);
                                devicepackage.setDevicerecordkey(device.getDevicerecordkey());
                                devicepackage.setUuid(uuid);
                                devicepackageList.add(devicepackage);
                            }
                            deviceService.insertDevicepackage(devicepackageList);

                            List<DataSetBean.DeviceStorageBean> deviceStorageBeans = dataSetBean.getDeviceStorage();
                            List<Devicestorage> devicestorageList = new ArrayList<>();
                            for (DataSetBean.DeviceStorageBean deviceStorageBean : deviceStorageBeans) {
                                Devicestorage devicestorage = WarehousBeanUtils.responseToDevicestorage(deviceStorageBean);
                                devicestorage.setDevicerecordkey(device.getDevicerecordkey());
                                devicestorage.setUuid(uuid);
                                devicestorageList.add(devicestorage);
                            }
                            deviceService.insertDevicestorage(devicestorageList);

                            List<DataSetBean.ContactListBean> contactListBeans = dataSetBean.getContactList();
                            List<Contactlist> contactlistList = new ArrayList<>();
                            for (DataSetBean.ContactListBean contactListBean : contactListBeans) {
                                Contactlist contactlist = WarehousBeanUtils.responseToContactlist(contactListBean);
                                contactlist.setDevicerecordkey(device.getDevicerecordkey());
                                contactlist.setUuid(uuid);
                                contactlistList.add(contactlist);
                            }
                            deviceService.insertContactlist(contactlistList);
                        }
                    }
                }
            }
        } else {
            return -1;
        }
        return 1;
    }

    public int downloadHistory(ProductInfoService productInfoService, DownloadHistoryRequest deviceHistoryRequest, DeviceService deviceService) {
        String response = HttpClient.post("sharing/history/get", deviceHistoryRequest);
        MedicalHistoryResonse medicalResonse = (MedicalHistoryResonse) JSONObject.parseObject(response, MedicalHistoryResonse.class);
        if (medicalResonse.getReturnCode() == 1) {
            List<DataSetBean> dataSetBeanList = medicalResonse.getDataList();
            if (dataSetBeanList != null && dataSetBeanList.size() > 0) {
                for (int i = 0; i < dataSetBeanList.size(); i++) {
                    DataSetBean dataSetBean = dataSetBeanList.get(i);
                    Device device = WarehousBeanUtils.responseToDevice(dataSetBean);
                    if (deviceService.selectisSame(device.getDevicerecordkey(), device.getVersionnumber()) == null) {
                        String uuid = getUUId();
                        device.setUuid(uuid);
                        device.setLastModifyTime(DateUtil.formatDateTime(new Date()));
                        deviceService.insertDevice(device);
                        new UdiTransferUtils().transUdi(deviceService, productInfoService, uuid, udiCompanyService);
                        List<DataSetBean.DeviceClinicalBean> deviceclinicals = dataSetBean.getDeviceClinical();
                        List<Deviceclinical> deviceclinicalList = new ArrayList<>();
                        for (DataSetBean.DeviceClinicalBean deviceClinicalBean : deviceclinicals) {
                            if (deviceClinicalBean != null) {
                                Deviceclinical deviceclinical = WarehousBeanUtils.responseToDeviceclinical(deviceClinicalBean);
                                deviceclinical.setDevicerecordkey(device.getDevicerecordkey());
                                deviceclinical.setUuid(uuid);
                                deviceclinicalList.add(deviceclinical);
                            }

                        }
                        deviceService.insertDeviceClinical(deviceclinicalList);

                        List<DataSetBean.DevicePackageBean> devicePackageBeans = dataSetBean.getDevicePackage();
                        List<Devicepackage> devicepackageList = new ArrayList<>();
                        for (DataSetBean.DevicePackageBean devicePackageBean : devicePackageBeans) {
                            Devicepackage devicepackage = WarehousBeanUtils.responseToDevicepackage(devicePackageBean);
                            devicepackage.setDevicerecordkey(device.getDevicerecordkey());
                            devicepackage.setUuid(uuid);
                            devicepackageList.add(devicepackage);
                        }
                        deviceService.insertDevicepackage(devicepackageList);

                        List<DataSetBean.DeviceStorageBean> deviceStorageBeans = dataSetBean.getDeviceStorage();
                        List<Devicestorage> devicestorageList = new ArrayList<>();
                        for (DataSetBean.DeviceStorageBean deviceStorageBean : deviceStorageBeans) {
                            Devicestorage devicestorage = WarehousBeanUtils.responseToDevicestorage(deviceStorageBean);
                            devicestorage.setDevicerecordkey(device.getDevicerecordkey());
                            devicestorage.setUuid(uuid);
                            devicestorageList.add(devicestorage);
                        }
                        deviceService.insertDevicestorage(devicestorageList);

                        List<DataSetBean.ContactListBean> contactListBeans = dataSetBean.getContactList();
                        List<Contactlist> contactlistList = new ArrayList<>();
                        for (DataSetBean.ContactListBean contactListBean : contactListBeans) {
                            Contactlist contactlist = WarehousBeanUtils.responseToContactlist(contactListBean);
                            contactlist.setDevicerecordkey(device.getDevicerecordkey());
                            contactlist.setUuid(uuid);
                            contactlistList.add(contactlist);
                        }
                        deviceService.insertContactlist(contactlistList);
                    }
                }
            }
        } else {
            return -1;
        }
        return 1;
    }

    public int downloadBydi(DownloadDiRequest downloadDiRequest, DeviceService deviceService, ProductInfoService productInfoService) {
        String response = HttpClient.post("sharing/single", downloadDiRequest);
        MedicalSingleResponse medicalResonse = (MedicalSingleResponse) JSONObject.parseObject(response, MedicalSingleResponse.class);
        if (medicalResonse.getReturnCode() == 1) {
            List<DataSetBean> dataSetBeanList = medicalResonse.getDataSet();
            if (dataSetBeanList != null && dataSetBeanList.size() > 0) {
                for (int i = 0; i < dataSetBeanList.size(); i++) {
                    DataSetBean dataSetBean = dataSetBeanList.get(i);
                    Device device = WarehousBeanUtils.responseToDevice(dataSetBean);
                    String uuid = getUUId();
                    device.setUuid(uuid);
                    if (deviceService.selectisSame(device.getDevicerecordkey(), device.getVersionnumber()) != null) {
                        return -1;
                    }
                    device.setLastModifyTime(DateUtil.formatDateTime(new Date()));
                    deviceService.insertDevice(device);
                    List<DataSetBean.DeviceClinicalBean> deviceclinicals = dataSetBean.getDeviceClinical();
                    List<Deviceclinical> deviceclinicalList = new ArrayList<>();
                    for (DataSetBean.DeviceClinicalBean deviceClinicalBean : deviceclinicals) {
                        if (deviceClinicalBean != null) {
                            Deviceclinical deviceclinical = WarehousBeanUtils.responseToDeviceclinical(deviceClinicalBean);
                            deviceclinical.setDevicerecordkey(device.getDevicerecordkey());
                            deviceclinical.setUuid(uuid);
                            deviceclinicalList.add(deviceclinical);
                        }
                    }
                    deviceService.insertDeviceClinical(deviceclinicalList);

                    List<DataSetBean.DevicePackageBean> devicePackageBeans = dataSetBean.getDevicePackage();
                    List<Devicepackage> devicepackageList = new ArrayList<>();
                    for (DataSetBean.DevicePackageBean devicePackageBean : devicePackageBeans) {
                        Devicepackage devicepackage = WarehousBeanUtils.responseToDevicepackage(devicePackageBean);
                        devicepackage.setDevicerecordkey(device.getDevicerecordkey());
                        devicepackage.setUuid(uuid);
                        devicepackageList.add(devicepackage);
                    }
                    deviceService.insertDevicepackage(devicepackageList);

                    List<DataSetBean.DeviceStorageBean> deviceStorageBeans = dataSetBean.getDeviceStorage();
                    List<Devicestorage> devicestorageList = new ArrayList<>();
                    for (DataSetBean.DeviceStorageBean deviceStorageBean : deviceStorageBeans) {
                        Devicestorage devicestorage = WarehousBeanUtils.responseToDevicestorage(deviceStorageBean);
                        devicestorage.setDevicerecordkey(device.getDevicerecordkey());
                        devicestorage.setUuid(uuid);
                        devicestorageList.add(devicestorage);
                    }
                    deviceService.insertDevicestorage(devicestorageList);

                    List<DataSetBean.ContactListBean> contactListBeans = dataSetBean.getContactList();
                    List<Contactlist> contactlistList = new ArrayList<>();
                    for (DataSetBean.ContactListBean contactListBean : contactListBeans) {
                        Contactlist contactlist = WarehousBeanUtils.responseToContactlist(contactListBean);
                        contactlist.setDevicerecordkey(device.getDevicerecordkey());
                        contactlist.setUuid(uuid);
                        contactlistList.add(contactlist);
                    }
                    deviceService.insertContactlist(contactlistList);

                    new UdiTransferUtils().transUdi(deviceService, productInfoService, uuid, udiCompanyService);
                }
            }
        } else {
            return -1;
        }
        return 1;
    }

    private String getUUId() {
        UUID uuid = UUID.randomUUID();
        return uuid.toString().replace("-", "");
    }

}
