package com.glxp.udidl.admin.entity.udid;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.List;

@Data
@ApiModel(value = "医疗器械信息")
public class DeviceEntity {


    /**
     * deviceRecordKey : 1BA24C4BF1416C236E58E814DBDE706B
     * versionNumber : 2
     * versionStatus : 更新
     * versionTime : 2020-08-24 09:52:05
     * deviceClinical : [{"id":1,"deviceRecordKey":"1BA24C4BF1416C236E58E814DBDE706B","lcsycclx":"","ccz":"","ccdw":""}]
     * devicePackage : [{"id":1,"deviceRecordKey":"1BA24C4BF1416C236E58E814DBDE706B","bzcpbs":"16949399321055","cpbzjb":"盒","bznhxyjcpbssl":12,"bznhxyjbzcpbs":"06949399321058"},{"id":2,"deviceRecordKey":"1BA24C4BF1416C236E58E814DBDE706B","bzcpbs":"26949399321052","cpbzjb":"箱","bznhxyjcpbssl":4,"bznhxyjbzcpbs":"16949399321055"}]
     * deviceStorage : [{"id":1,"deviceRecordKey":"1BA24C4BF1416C236E58E814DBDE706B","cchcztj":"湿度","zdz":"0","zgz":"80","jldw":"%RH"}]
     * contactList : [{"id":1,"deviceRecordKey":"1BA24C4BF1416C236E58E814DBDE706B","qylxryx":"ahaofohhc@163.com","qylxrdh":"0552-2088222","qylxrcz":"0552-2053891"}]
     * tsrq :
     * qtxxdwzlj :
     * scbssfbhsxrq : 是
     * scbssfbhscrq : 是
     * scbssfbhph : 是
     * scbssfbhxlh : 否
     * tsccsm :
     * tscchcztj : 本产品应储存在通风良好，干燥清洁，湿度不超过80%RH的室内，严禁与腐蚀性物品混堆；须防止运输过程中的剧烈冲击、震动及硬物刮蹭，保持包装完整；贮存与运输时请勿重压，避免日晒和雨雪淋溅。
     * qxlb : 器械
     * cplb : 耗材
     * yflbm :
     * sfwwjbz : 是
     * syqsfxyjxmj : 否
     * cgzmraqxgxx : 说明书或标签上面不包含MR安全性信息
     * ybbm :
     * sydycpbs :
     * btcpbs :
     * cpms : 产品包括腹腔穿刺器(FQ型)和胸腔穿刺器(XQ型)两种型号。腹腔穿刺器FQ型由穿刺椎、穿刺套管、自调式密封帽和保护套(3mm、 5.5mm规格的不含自调式密封帽)组成，穿刺杆采用ABS (台湾台美)颗粒，穿刺椎头，穿刺环形套管采用PC-2858颗粒(德国拜耳)制成;胸腔穿刺器XQ型由穿刺椎和穿刺套组成，其中穿刺椎由穿刺杆和手柄组成,穿刺套由柔性套管和套管密封套组成，采用医用高分子材料制成。产品应无菌。
     * zxxsdycpbs : 06949399321058
     * flbm : 02
     * cphhhbh :
     * ylqxzcrbarmc : 安徽奥弗医疗设备科技股份有限公司
     * cpmctymc : 穿刺器
     * spmc : 穿刺器
     * ggxh : XQ/15mm×80mm
     * sfybtzjbs : 否
     * sfwblztlcp : 否
     * zdcfsycs :
     * mjfs :
     * cpbsfbrq : 2020-06-18
     * tyshxydm : 91340300684969073C
     * cpbsbmtxmc : GS1
     * btcpbsyzxxsdycpbssfyz :
     * sfbjwycxsy : 是
     * ylqxzcrbarywmc :
     * zczbhhzbapzbh : 皖械注准20202020172;,皖械注准20152150140
     * zxxsdyzsydydsl : 1
     */

    @ApiModelProperty(value = "uuid")
    private String uuid;

    @ApiModelProperty(value = "主键编号")
    private String devicerecordkey;

    @ApiModelProperty(value = "本体产品标识")
    private String btcpbs;

    @ApiModelProperty(value = "")
    private String btcpbsyzxxsdycpbssfyz;

    @ApiModelProperty(value = "最小销售单元产品标识")
    private String zxxsdycpbs;

    @ApiModelProperty(value = "磁共振（MR）安全相关信息")
    private String cgzmraqxgxx;

    @ApiModelProperty(value = "医疗器械唯一标识编码体系名称")
    private String cpbsbmtxmc;

    @ApiModelProperty(value = "产品标识发布日期")
    private String cpbsfbrq;

    @ApiModelProperty(value = "产品货号或编号")
    private String cphhhbh;

    @ApiModelProperty(value = "产品类别")
    private String cplb;

    @ApiModelProperty(value = "产品名称/通用名称")
    private String cpmctymc;

    @ApiModelProperty(value = "产品描述")
    private String cpms;

    @ApiModelProperty(value = "分类编码")
    private String flbm;

    @ApiModelProperty(value = "规格型号")
    private String ggxh;

    @ApiModelProperty(value = "灭菌方式")
    private String mjfs;

    @ApiModelProperty(value = "其他信息的网址链接")
    private String qtxxdwzlj;

    @ApiModelProperty(value = "器械类别")
    private String qxlb;

    @ApiModelProperty(value = "生产标识是否包含批号")
    private String scbssfbhph;

    @ApiModelProperty(value = "生产标识是否包含生产日期")
    private String scbssfbhscrq;

    @ApiModelProperty(value = "是否包含失效日期")
    private String scbssfbhsxrq;

    @ApiModelProperty(value = "生产标识是否包含序列号")
    private String scbssfbhxlh;

    @ApiModelProperty(value = "是否标记为一次性使用")
    private String sfbjwycxsy;

    @ApiModelProperty(value = "是否为包类/组套类产品")
    private String sfwblztlcp;

    @ApiModelProperty(value = "是否为无菌包装")
    private String sfwwjbz;

    @ApiModelProperty(value = "是否有本体直接标识")
    private String sfybtzjbs;

    @ApiModelProperty(value = "商品名称")
    private String spmc;

    @ApiModelProperty(value = "使用单元产品标识")
    private String sydycpbs;

    @ApiModelProperty(value = "")
    private String syqsfxyjxmj;

    @ApiModelProperty(value = "特殊储存或操作条件")
    private String tscchcztj;

    @ApiModelProperty(value = "特殊尺寸说明")
    private String tsccsm;

    @ApiModelProperty(value = "退市日期")
    private String tsrq;

    @ApiModelProperty(value = "信用代码")
    private String tyshxydm;

    @ApiModelProperty(value = "公开的版本号")
    private String versionnumber;

    @ApiModelProperty(value = "版本的状态")
    private String versionstatus;

    @ApiModelProperty(value = "版本的发布时间")
    private String versiontime;

    @ApiModelProperty(value = "医保编码")
    private String ybbm;

    @ApiModelProperty(value = "原分类编码")
    private String yflbm;

    @ApiModelProperty(value = "医疗器械注册人名称")
    private String ylqxzcrbarmc;

    @ApiModelProperty(value = "医疗器械注册人/备案人英文名称")
    private String ylqxzcrbarywmc;

    @ApiModelProperty(value = "注册证编号或者备案凭证编号")
    private String zczbhhzbapzbh;

    @ApiModelProperty(value = "最大重复使用次数")
    private String zdcfsycs;

    @ApiModelProperty(value = "")
    private String bszt;

    @ApiModelProperty(value = "")
    private String sfyzcbayz;

    @ApiModelProperty(value = "注册/备案产品标识")
    private String zcbacpbs;

    @ApiModelProperty(value = "最小销售单元中使用单元的数量")
    private String zxxsdyzsydydsl;

    @ApiModelProperty(value = "历史主键编号")
    private String devicehistoryrecordkey;

    @ApiModelProperty(value = "发布状态")
    private String bssjzt;

    @ApiModelProperty(value = "")
    private boolean check;

    private String hchzsb;

    @ApiModelProperty(value = "产品类型")
    private String cplx;

    @ApiModelProperty(value = "联系人信息")
    private List<Contactlist> contactlistList;

    @ApiModelProperty(value = "临床器械信息")
    private List<Deviceclinical> deviceclinicals;

    @ApiModelProperty(value = "医疗器械包装信息")
    private List<Devicepackage> devicepackages;

    @ApiModelProperty(value = "医疗器械存储信息")
    private List<Devicestorage> devicestorages;

    @ApiModelProperty(value = "医疗器械历史信息")
    private List<DeviceHistory> deviceHistories;

}
